'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _eosjsEcc = require('eosjs-ecc');

var _eosjsEcc2 = _interopRequireDefault(_eosjsEcc);

var _eos = require('./services/eos');

var eos = _interopRequireWildcard(_eos);

var _identity = require('./services/identity');

var _identity2 = _interopRequireDefault(_identity);

var _reputation = require('./services/reputation');

var _reputation2 = _interopRequireDefault(_reputation);

var _security = require('./services/security');

var _security2 = _interopRequireDefault(_security);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class RIDL {

    constructor() {
        this.identity = new _identity2.default();
        this.reputation = new _reputation2.default();
        this.security = new _security2.default();
    }

    /***
     * Initializes RIDL for a specified account. Can be re-initialized as
     * many times as needed.
     * -------------------------------
     * Can be initialized as a reader only by passing nulls into the
     * account and signProvider parameters.
     * @param network
     * @param account
     * @param signProvider
     * @returns {Promise}
     */
    init(network, account = null, signProvider = null) {
        return eos.init(network, account, signProvider);
    }

    canConnect() {
        return eos.canConnect();
    }

}

exports.default = new RIDL();